from xmlrpc.server import SimpleXMLRPCServer

class Forecast(object):
    """
    Reprezentuje predpoved. V instancnich promennych jsou reprezentovany hodnoty
    predpovedi.
    """

    def __init__(self, description, wind_force, temperature):
        """
        Konstruktor predpovedi. Instancni promenne reprezentuji predana data.
        """
        pass

    def get_list(self):
        """
        Vraci trojici reprezentujici predpoved.
        """
        pass

class ForecastCalendar(object):
    """
    Reprezentuje predpovedi pro nekolik dni. Data predpovedi jsou ulozena ve
    slovniku. Klicem je datum, hodnotou pak instance tridy Forecast. Vkladani
    predpovedi metodou update_forecast je chraneno heslem, ktere je predano v
    konstruktoru. Startovaci data jsou take predana v konstruktoru.
    """

    def __init__(self, initial_values, password):
        """
        Konstruktor kalendare predpovedi. Instancni promenne reprezentuji predana data.
        """
        pass

    def get_forecast(self, date):
        """
        Vrati predpoved pro zadane datum jako list. V pripade, ze pro dane
        datum neexistuje predpoved. Vrati se retezec 'No focecast'.
        """
        return 'No forecast'

    def update_forecast(self, password, date, description, wind_force, temperature):
        """
        Aktualizuje predpoved pro zadane datum. Akce je chranena heslem. Pokud
        heslo nesouhlasi s heslem, ktere je zadano v konstruktoru, neni mozno
        aktualizovat predpoved. V takovem pripade metoda vrati retezec 'No
        update'. Metoda muze aktualizovat stavajici predpoved nebo pridat novou.
        """
        return 'No update'

def main():

    # TODO Pridat do initial_state data predpovedi tak, aby je mohl klient
    # precist.
    initial_state = {}

    fcalendar = ForecastCalendar(initial_state, password = 'master-of-weather')

    server_address = ('localhost', 10001)
    server = SimpleXMLRPCServer(server_address)
    server.register_instance(fcalendar)
    server.register_introspection_functions()
    print('Starting Weather XML-RPC server, use <Ctrl-C> to stop')
    server.serve_forever()

if __name__ == '__main__':
    main()
